.SUFFIXES: .asm

# defines
MAKEFILE=Makefile
MAKEDEP=$(MAKEFILE)
NASM	=nasm -f elf
GLIBC   =../../libc
LSCRIPT	=./link.ld
LFLAGS	=-g -T$(LSCRIPT)
INCDIR	=$(GLIBC)/include
CC	=gcc -m32 -g -O2 -Wall -W -c -nostdinc -fno-builtin -fno-stack-protector -I$(INCDIR)
#-Wall -W
LD	=ld -m elf_i386 -s -nostdlib
LIBC    =$(GLIBC)/libc.a
OBJS	=start.o main.o

# targets
all: sh

install: sh
	mkdir mnt
	mount /dev/fd0 mnt
	cp -f sh ./mnt/sh
	umount mnt
	rmdir mnt

iso: sh
	cp sh ../../iso/

clean:
	rm -f *.o sh sh.img $(OBJS)

# implicit rules
.s.o:
	$(NASM) -o$@ $<

.c.o:
	$(CC) -c -o$@ $<

# explicit rules
sh: $(OBJS) $(LIBC) $(MAKEDEP)
	$(LD) $(LFLAGS) -o$@ $(OBJS) $(LIBC)